VTK: RTW::OSPRayBackend Class Reference

| VTK 9.3.1

Public Member Functions | List of all members
RTW::OSPRayBackend Class Reference

`#include <OSPRayBackend.h>`

Inheritance diagram for RTW::OSPRayBackend:
[legend]
Collaboration diagram for RTW::OSPRayBackend:
[legend]

## Public Member Functions
RTWError | Init () override
void | Shutdown () override
bool | IsSupported (RTWFeature feature) const override
RTWData | NewCopyData1D (const void *source, RTWDataType dataType, size_t numElements) override
RTWData | NewCopyData2D (const void *source, RTWDataType dataType, size_t numElements, size_t numElements2) override
RTWData | NewCopyData3D (const void *source, RTWDataType dataType, size_t numElements, size_t numElements2, size_t numElements3) override
RTWData | NewData (RTWDataType dataType, size_t numElements) override
RTWGeometry | NewGeometry (const char *type) override
RTWGroup | NewGroup () override
RTWData | NewSharedData1D (const void *sharedData, RTWDataType type, uint32_t numItems1) override
RTWData | NewSharedData2D (const void *sharedData, RTWDataType type, uint32_t numItems1, uint32_t numItems2) override
RTWData | NewSharedData3D (const void *sharedData, RTWDataType type, uint32_t numItems1, uint32_t numItems2, uint32_t numItems3) override
RTWTexture | NewTexture (const char *type) override
RTWLight | NewLight (const char *light_type) override
RTWMaterial | NewMaterial (const char *renderer_type, const char *material_type) override
RTWVolume | NewVolume (const char *type) override
RTWTransferFunction | NewTransferFunction (const char *type) override
RTWRenderer | NewRenderer (const char *type) override
RTWCamera | NewCamera (const char *type) override
RTWGeometricModel | NewGeometricModel (RTWGeometry geometry) override
RTWVolumetricModel | NewVolumetricModel (RTWVolume volume) override
RTWWorld | NewWorld () override
RTWInstance | NewInstance (RTWGroup geometry) override
RTWFrameBuffer | NewFrameBuffer (const rtw::vec2i &size, const RTWFrameBufferFormat format, const uint32_t frameBufferChannels) override
void | Release (RTWObject object) override
void | SetString (RTWObject object, const char *id, const char *s) override
void | SetObject (RTWObject object, const char *id, RTWObject other) override
void | SetObjectAsData (RTWObject target, const char *id, RTWDataType type, RTWObject obj) override
void | SetParam (RTWObject object, const char *id, RTWDataType dataType, const void *mem) override
void | SetInt (RTWObject object, const char *id, int32_t x) override
void | SetBool (RTWObject object, const char *id, bool x) override
void | SetFloat (RTWObject object, const char *id, float x) override
void | SetVec2f (RTWObject object, const char *id, float x, float y) override
void | SetVec2i (RTWObject object, const char *id, int x, int y) override
void | SetVec3i (RTWObject object, const char *id, int x, int y, int z) override
void | SetVec3f (RTWObject object, const char *id, float x, float y, float z) override
void | SetVec4f (RTWObject object, const char *id, float x, float y, float z, float w) override
void | RemoveParam (RTWObject object, const char *id) override
void | Commit (RTWObject object) override
float | RenderFrame (RTWFrameBuffer frameBuffer, RTWRenderer renderer, RTWCamera camera, RTWWorld world) override
void | FrameBufferClear (RTWFrameBuffer frameBuffer) override
const void * | MapFrameBuffer (RTWFrameBuffer frameBuffer, const RTWFrameBufferChannel channel) override
void | UnmapFrameBuffer (const void *mapped, RTWFrameBuffer frameBuffer) override
void | SetDepthNormalizationGL (RTWFrameBuffer, float, float) override
int | GetColorTextureGL (RTWFrameBuffer) override
int | GetDepthTextureGL (RTWFrameBuffer) override
Public Member Functions inherited from RTW::Backend
virtual | ~Backend ()=default
virtual void | SetVec2i (RTWObject, const char *id, int32_t x, int32_t y)=0

## Detailed Description

Definition at line 73 of file OSPRayBackend.h.

## Member Function Documentation

## ◆ Init()

RTWError RTW::OSPRayBackend::Init | ( |  | ) |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 76 of file OSPRayBackend.h.

## ◆ Shutdown()

void RTW::OSPRayBackend::Shutdown | ( |  | ) |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 101 of file OSPRayBackend.h.

## ◆ IsSupported()

bool RTW::OSPRayBackend::IsSupported | ( | RTWFeature | feature | ) | const
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 106 of file OSPRayBackend.h.

## ◆ NewCopyData1D()

RTWData RTW::OSPRayBackend::NewCopyData1D | ( | const void * | source,
|  | RTWDataType | dataType,
|  | size_t | numElements
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 126 of file OSPRayBackend.h.

## ◆ NewCopyData2D()

RTWData RTW::OSPRayBackend::NewCopyData2D | ( | const void * | source,
|  | RTWDataType | dataType,
|  | size_t | numElements,
|  | size_t | numElements2
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 137 of file OSPRayBackend.h.

## ◆ NewCopyData3D()

RTWData RTW::OSPRayBackend::NewCopyData3D | ( | const void * | source,
|  | RTWDataType | dataType,
|  | size_t | numElements,
|  | size_t | numElements2,
|  | size_t | numElements3
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 148 of file OSPRayBackend.h.

## ◆ NewData()

RTWData RTW::OSPRayBackend::NewData | ( | RTWDataType | dataType,
|  | size_t | numElements
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 160 of file OSPRayBackend.h.

## ◆ NewGeometry()

RTWGeometry RTW::OSPRayBackend::NewGeometry | ( | const char * | type | ) |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 165 of file OSPRayBackend.h.

## ◆ NewGroup()

RTWGroup RTW::OSPRayBackend::NewGroup | ( |  | ) |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 170 of file OSPRayBackend.h.

## ◆ NewSharedData1D()

RTWData RTW::OSPRayBackend::NewSharedData1D | ( | const void * | sharedData,
|  | RTWDataType | type,
|  | uint32_t | numItems1
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 175 of file OSPRayBackend.h.

## ◆ NewSharedData2D()

RTWData RTW::OSPRayBackend::NewSharedData2D | ( | const void * | sharedData,
|  | RTWDataType | type,
|  | uint32_t | numItems1,
|  | uint32_t | numItems2
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 180 of file OSPRayBackend.h.

## ◆ NewSharedData3D()

RTWData RTW::OSPRayBackend::NewSharedData3D | ( | const void * | sharedData,
|  | RTWDataType | type,
|  | uint32_t | numItems1,
|  | uint32_t | numItems2,
|  | uint32_t | numItems3
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 185 of file OSPRayBackend.h.

## ◆ NewTexture()

RTWTexture RTW::OSPRayBackend::NewTexture | ( | const char * | type | ) |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 192 of file OSPRayBackend.h.

## ◆ NewLight()

RTWLight RTW::OSPRayBackend::NewLight | ( | const char * | light_type | ) |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 197 of file OSPRayBackend.h.

## ◆ NewMaterial()

RTWMaterial RTW::OSPRayBackend::NewMaterial | ( | const char * | renderer_type,
|  | const char * | material_type
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 202 of file OSPRayBackend.h.

## ◆ NewVolume()

RTWVolume RTW::OSPRayBackend::NewVolume | ( | const char * | type | ) |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 207 of file OSPRayBackend.h.

## ◆ NewTransferFunction()

RTWTransferFunction RTW::OSPRayBackend::NewTransferFunction | ( | const char * | type | ) |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 212 of file OSPRayBackend.h.

## ◆ NewRenderer()

RTWRenderer RTW::OSPRayBackend::NewRenderer | ( | const char * | type | ) |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 217 of file OSPRayBackend.h.

## ◆ NewCamera()

RTWCamera RTW::OSPRayBackend::NewCamera | ( | const char * | type | ) |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 222 of file OSPRayBackend.h.

## ◆ NewGeometricModel()

RTWGeometricModel RTW::OSPRayBackend::NewGeometricModel | ( | RTWGeometry | geometry | ) |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 227 of file OSPRayBackend.h.

## ◆ NewVolumetricModel()

RTWVolumetricModel RTW::OSPRayBackend::NewVolumetricModel | ( | RTWVolume | volume | ) |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 232 of file OSPRayBackend.h.

## ◆ NewWorld()

RTWWorld RTW::OSPRayBackend::NewWorld | ( |  | ) |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 237 of file OSPRayBackend.h.

## ◆ NewInstance()

RTWInstance RTW::OSPRayBackend::NewInstance | ( | RTWGroup | geometry | ) |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 242 of file OSPRayBackend.h.

## ◆ NewFrameBuffer()

RTWFrameBuffer RTW::OSPRayBackend::NewFrameBuffer | ( | const rtw::vec2i & | size,
|  | const RTWFrameBufferFormat | format,
|  | const uint32_t | frameBufferChannels
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 247 of file OSPRayBackend.h.

## ◆ Release()

void RTW::OSPRayBackend::Release | ( | RTWObject | object | ) |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 252 of file OSPRayBackend.h.

## ◆ SetString()

void RTW::OSPRayBackend::SetString | ( | RTWObject | object,
|  | const char * | id,
|  | const char * | s
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 257 of file OSPRayBackend.h.

## ◆ SetObject()

void RTW::OSPRayBackend::SetObject | ( | RTWObject | object,
|  | const char * | id,
|  | RTWObject | other
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 262 of file OSPRayBackend.h.

## ◆ SetObjectAsData()

void RTW::OSPRayBackend::SetObjectAsData | ( | RTWObject | target,
|  | const char * | id,
|  | RTWDataType | type,
|  | RTWObject | obj
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 267 of file OSPRayBackend.h.

## ◆ SetParam()

void RTW::OSPRayBackend::SetParam | ( | RTWObject | object,
|  | const char * | id,
|  | RTWDataType | dataType,
|  | const void * | mem
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 272 of file OSPRayBackend.h.

## ◆ SetInt()

void RTW::OSPRayBackend::SetInt | ( | RTWObject | object,
|  | const char * | id,
|  | int32_t | x
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 278 of file OSPRayBackend.h.

## ◆ SetBool()

void RTW::OSPRayBackend::SetBool | ( | RTWObject | object,
|  | const char * | id,
|  | bool | x
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 283 of file OSPRayBackend.h.

## ◆ SetFloat()

void RTW::OSPRayBackend::SetFloat | ( | RTWObject | object,
|  | const char * | id,
|  | float | x
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 288 of file OSPRayBackend.h.

## ◆ SetVec2f()

void RTW::OSPRayBackend::SetVec2f | ( | RTWObject | object,
|  | const char * | id,
|  | float | x,
|  | float | y
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 293 of file OSPRayBackend.h.

## ◆ SetVec2i()

void RTW::OSPRayBackend::SetVec2i | ( | RTWObject | object,
|  | const char * | id,
|  | int | x,
|  | int | y
| ) |  |
| inlineoverride

Definition at line 298 of file OSPRayBackend.h.

## ◆ SetVec3i()

void RTW::OSPRayBackend::SetVec3i | ( | RTWObject | object,
|  | const char * | id,
|  | int | x,
|  | int | y,
|  | int | z
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 303 of file OSPRayBackend.h.

## ◆ SetVec3f()

void RTW::OSPRayBackend::SetVec3f | ( | RTWObject | object,
|  | const char * | id,
|  | float | x,
|  | float | y,
|  | float | z
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 308 of file OSPRayBackend.h.

## ◆ SetVec4f()

void RTW::OSPRayBackend::SetVec4f | ( | RTWObject | object,
|  | const char * | id,
|  | float | x,
|  | float | y,
|  | float | z,
|  | float | w
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 313 of file OSPRayBackend.h.

## ◆ RemoveParam()

void RTW::OSPRayBackend::RemoveParam | ( | RTWObject | object,
|  | const char * | id
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 318 of file OSPRayBackend.h.

## ◆ Commit()

void RTW::OSPRayBackend::Commit | ( | RTWObject | object | ) |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 323 of file OSPRayBackend.h.

## ◆ RenderFrame()

float RTW::OSPRayBackend::RenderFrame | ( | RTWFrameBuffer | frameBuffer,
|  | RTWRenderer | renderer,
|  | RTWCamera | camera,
|  | RTWWorld | world
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 328 of file OSPRayBackend.h.

## ◆ FrameBufferClear()

void RTW::OSPRayBackend::FrameBufferClear | ( | RTWFrameBuffer | frameBuffer | ) |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 334 of file OSPRayBackend.h.

## ◆ MapFrameBuffer()

const void* RTW::OSPRayBackend::MapFrameBuffer | ( | RTWFrameBuffer | frameBuffer,
|  | const RTWFrameBufferChannel | channel
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 339 of file OSPRayBackend.h.

## ◆ UnmapFrameBuffer()

void RTW::OSPRayBackend::UnmapFrameBuffer | ( | const void * | mapped,
|  | RTWFrameBuffer | frameBuffer
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 344 of file OSPRayBackend.h.

## ◆ SetDepthNormalizationGL()

void RTW::OSPRayBackend::SetDepthNormalizationGL | ( | RTWFrameBuffer | ,
|  | float | ,
|  | float |
| ) |  |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 349 of file OSPRayBackend.h.

## ◆ GetColorTextureGL()

int RTW::OSPRayBackend::GetColorTextureGL | ( | RTWFrameBuffer |  | ) |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 354 of file OSPRayBackend.h.

## ◆ GetDepthTextureGL()

int RTW::OSPRayBackend::GetDepthTextureGL | ( | RTWFrameBuffer |  | ) |
| inlineoverridevirtual

Implements RTW::Backend.

Definition at line 360 of file OSPRayBackend.h.

The documentation for this class was generated from the following file:

- Rendering/RayTracing/RTWrapper/OSPRay/OSPRayBackend.h